#ifndef ADAM_H
#define ADAM_H
#include <adept.h>

//extern adept::Stack stack;

#define MINIBATCH_SIZE 0.1
#define ADAM

# include <improved_rnn.h>
# include <genetic.h>
typedef vector<double> Data;

class adam
{
public:
    adam(Genetic *pp,nikolas::rnn **p,Data initialx,int max,Dataset *tr,unsigned maxTh = 8);
    ~adam();
    void run();
    Data getResult();
private:
    Genetic *pgen;
    adept::Stack stack;
    void setAdeptGrad();
    unsigned threads;
    double offset = 0;
    Dataset *d;
    nikolas::rnn **pf;
    nikolas::rnn *privateRnn;
    double a = 0.001; //learning rate
    unsigned maxSteps=100;
    float b1 = 0.9;
    float b2 = 0.999;
    double eps = 0.001;
    double *grad;
    double *adeptGrad;
    double *m;
    double *v;
    double getFit();
    Data newW;
    adouble comp(vector<adept::adouble> x);
};

#endif // ADAM_H
