# ifndef __TOLMIN__H
# define __TOLMIN__H
# include <genetic.h>
#include "adept.h"
#include <improved_rnn.h>

#ifdef __cplusplus
extern "C"{
# endif

typedef struct MinInfo
{
    Genetic		*p;
    nikolas::rnn        **pf;
    Dataset             *d;
	int		iters;
    adept::Stack *s;
    nikolas::rnn *r;
};
extern double	tolmin(Data &x,MinInfo &Info);

#ifdef __cplusplus
}
#endif

# endif
