#ifndef A_GSL_BFGS_H
#define A_GSL_BFGS_H

#include <gsl/gsl_multimin.h>
#include <adept.h>
#include "dataset.h"
#include "improved_rnn.h"
#include "tolmin.h"
//extern adept::Stack stack;

typedef vector<double> Data;
typedef struct params{
    Dataset *d;
    nikolas::rnn *r;
    unsigned size;
    Data xm;
    adept::Stack *stack;
} Params;


extern void	getGranal(vector<double> &x,nikolas::rnn **pf,Dataset *d,vector<double> &g,MinInfo &I);
extern double getFunmin(vector<double> &x,nikolas::rnn **pf,Dataset *d);
/*
class a_gsl_bfgs
{
public:
    a_gsl_bfgs(nikolas::rnn **p,Data &initialx,int max,Dataset *tr);
    ~a_gsl_bfgs();
    void run();
    Data getResults();
private :
    Dataset *d;
    nikolas::rnn **pf;
    nikolas::rnn *prive;
    adept::Stack stack;
    Data xm;
    int maxSteps;
    double *dweights;

    gsl_vector *x1;

    //void setAdeptGrad(double *grad);

    /*

    void getdFit(const gsl_vector * x, void * params, gsl_vector * g);
    double getFit(const gsl_vector * x, void * params);


    adouble comp(vector<adept::adouble> x);*/
/*
};*/

#endif // A_GSL_BFGS_H
